For the complete documentation index, see llms.txt. This page is also available as Markdown.

Partially modify NICs

Update the properties of the specified NIC.

patch
Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials.

Note:

  • Basic Authentication is supported only when 2-Factor Authentication is not configured.
  • Users with 2-Factor Authentication activated must generate new 2FA-secured tokens in the DCD using [Token Manager](https://docs.ionos.com/cloud/set-up-ionos-cloud/management/identity-access-management/token-manager). These tokens do not inherit the 2FA-secured property by default.
  • Token deletion is only possible using the Token Manager.
Separate your username and password with a colon, i.e., username:password and send it as 'Authorization' request header. More details: https://en.wikipedia.org/wiki/Basic_access_authentication
Path parameters
datacenterIdstringRequired

The unique ID of the data center.

serverIdstringRequired

The unique ID of the server.

nicIdstringRequired

The unique ID of the NIC.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Body
namestringOptional

The name of the resource.

Example: My resource
macstringOptional

The MAC address of the NIC. On NIC creation you can specify a custom MAC address. If you do not provide one, a MAC address will be automatically assigned. Ensure that any custom MAC address is unicast, adhering to the format xy:xx:xx:xx:xx:xx. Here, x represents any hexadecimal digit (0-9, a-f, A-F), and y must be precisely one of 0, 2, 4, 6, 8, A, C, E (or equivalently a, c, e) to conform with unicast addressing requirements. Two NICs from the same server may not have the same MAC address. Two NICs on the same LAN can but should not have the same MAC address.

Example: 00:0a:95:9d:68:16
ipsstring[] · nullableOptional

Collection of IP addresses, assigned to the NIC. Explicitly assigned public IPs need to come from reserved IP blocks. Passing value null or empty array will assign an IP address automatically. On a private LAN, an automatically assigned IP never ends in .0 to .9 or .224 to .255 and is never the first host or the broadcast address of the LAN's IPv4 CIDR block, so a /28 starting at .0 offers only .10 to .14. Any address of the block can still be set explicitly. When no automatically assignable IP is left, a NIC without an explicit IP is rejected.

Example: ["10.160.12.12"]
dhcpbooleanOptional

Indicates if the NIC will reserve an IP using DHCP.

Default: trueExample: true
ipv6Ipsstring[] · nullableOptional

If this NIC is connected to an IPv6 enabled LAN then this property contains the IPv6 IP addresses of the NIC. The maximum number of IPv6 IP addresses per NIC is 50, if you need more, contact support. If you leave this property 'null' when adding a NIC, when changing the NIC's IPv6 CIDR block, when changing the LAN's IPv6 CIDR block or when moving the NIC to a different IPv6 enabled LAN, then we will automatically assign the same number of IPv6 addresses which you had before from the NICs new CIDR block. If you leave this property 'null' while not changing the CIDR block, the IPv6 IP addresses won't be changed either. You can also provide your own self choosen IPv6 addresses, which then must be inside the IPv6 CIDR block of this NIC.

Example: ["2001:db8:b06d:8f5a:0609::1"]
ipv6CidrBlockstring · nullableOptional

If this NIC is connected to an IPv6 enabled LAN then this property contains the /80 IPv6 CIDR block of the NIC. If you leave this property 'null' when adding a NIC to an IPv6-enabled LAN, then an IPv6 CIDR block will automatically be assigned to the NIC, but you can also specify an /80 IPv6 CIDR block for the NIC on your own, which must be inside the /64 IPv6 CIDR block of the LAN and unique. This value can only be set, if the LAN already has an IPv6 CIDR block assigned. An IPv6-enabled LAN is limited to a maximum of 65,536 NICs.

Example: 2001:db8:b06d:8f5a:0609::/80
dhcpv6boolean · nullableOptional

Indicates if the NIC will receive an IPv6 using DHCP. It can be set to 'true' or 'false' only if this NIC is connected to an IPv6 enabled LAN.

Default: trueExample: true
laninteger · int32Required

The LAN ID the NIC will be on. If the LAN ID does not exist, it will be implicitly created.

Example: 2
firewallActivebooleanOptional

Activate or deactivate the firewall. By default, an active firewall without any defined rules will block all incoming network traffic except for the firewall rules that explicitly allows certain protocols, IP addresses and ports.

Example: false
firewallTypestring · enumOptional

The type of firewall rules that will be allowed on the NIC. If not specified, the default INGRESS value is used.

Example: INGRESSPossible values:
deviceNumberinteger · int32Read-onlyOptional

The Logical Unit Number (LUN) of the storage volume. Null if this NIC was created using Cloud API and no DCD changes were performed on the Datacenter.

Example: 3
pciSlotinteger · int32Read-onlyOptional

The PCI slot number for the NIC.

Example: 7
vnetstringOptional

The vnet ID that belongs to this NIC; Requires system privileges, for internal usage only

Responses
202

Successful operation

application/json
patch/datacenters/{datacenterId}/servers/{serverId}/nics/{nicId}
PATCH /cloudapi/v6/datacenters/{datacenterId}/servers/{serverId}/nics/{nicId} HTTP/1.1
Host: api.ionos.com
Authorization: Basic username:password
Content-Type: application/json
Accept: */*
Content-Length: 253

{
  "name": "My resource",
  "mac": "00:0a:95:9d:68:16",
  "ips": [
    "10.160.12.12"
  ],
  "dhcp": true,
  "ipv6Ips": [
    "2001:db8:b06d:8f5a:0609::1"
  ],
  "ipv6CidrBlock": "2001:db8:b06d:8f5a:0609::/80",
  "dhcpv6": true,
  "lan": 2,
  "firewallActive": false,
  "firewallType": "INGRESS",
  "vnet": null
}
{
  "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
  "type": "nic",
  "href": "<RESOURCE-URI>",
  "metadata": {
    "etag": "45480eb3fbfc31f1d916c1eaa4abdcc3",
    "createdDate": "2015-12-04T14:34:09.809Z",
    "createdBy": "user@example.com",
    "createdByUserId": "user@example.com",
    "lastModifiedDate": "2015-12-04T14:34:09.809Z",
    "lastModifiedBy": "user@example.com",
    "lastModifiedByUserId": "63cef532-26fe-4a64-a4e0-de7c8a506c90",
    "state": "AVAILABLE"
  },
  "properties": {
    "name": "My resource",
    "mac": "00:0a:95:9d:68:16",
    "ips": [
      "10.160.12.12"
    ],
    "dhcp": true,
    "ipv6Ips": [
      "2001:db8:b06d:8f5a:0609::1"
    ],
    "ipv6CidrBlock": "2001:db8:b06d:8f5a:0609::/80",
    "dhcpv6": true,
    "lan": 2,
    "firewallActive": false,
    "firewallType": "INGRESS",
    "deviceNumber": 3,
    "pciSlot": 7,
    "vnet": null
  },
  "entities": {
    "flowlogs": {
      "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
      "type": "collection",
      "href": "<RESOURCE-URI>",
      "items": [
        {
          "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
          "type": "flow-log",
          "href": "<RESOURCE-URI>",
          "metadata": {
            "etag": "45480eb3fbfc31f1d916c1eaa4abdcc3",
            "createdDate": "2015-12-04T14:34:09.809Z",
            "createdBy": "user@example.com",
            "createdByUserId": "user@example.com",
            "lastModifiedDate": "2015-12-04T14:34:09.809Z",
            "lastModifiedBy": "user@example.com",
            "lastModifiedByUserId": "63cef532-26fe-4a64-a4e0-de7c8a506c90",
            "state": "AVAILABLE"
          },
          "properties": {
            "name": "My resource",
            "action": "ACCEPTED",
            "direction": "INGRESS",
            "bucket": "bucketName/key"
          }
        }
      ],
      "offset": 0,
      "limit": 1000,
      "_links": {
        "prev": "<PREVIOUS-PAGE-URI>",
        "self": "<THIS-PAGE-URI>",
        "next": "<NEXT-PAGE-URI>"
      }
    },
    "firewallrules": {
      "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
      "type": "collection",
      "href": "<RESOURCE-URI>",
      "items": [
        {
          "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
          "type": "firewall-rule",
          "href": "<RESOURCE-URI>",
          "metadata": {
            "etag": "45480eb3fbfc31f1d916c1eaa4abdcc3",
            "createdDate": "2015-12-04T14:34:09.809Z",
            "createdBy": "user@example.com",
            "createdByUserId": "user@example.com",
            "lastModifiedDate": "2015-12-04T14:34:09.809Z",
            "lastModifiedBy": "user@example.com",
            "lastModifiedByUserId": "63cef532-26fe-4a64-a4e0-de7c8a506c90",
            "state": "AVAILABLE"
          },
          "properties": {
            "name": "My resource",
            "protocol": "TCP",
            "sourceMac": "00:0a:95:9d:68:16",
            "ipVersion": "IPv4",
            "sourceIp": "22.231.113.64",
            "targetIp": "22.231.113.64",
            "icmpCode": 0,
            "icmpType": 8,
            "portRangeStart": 8,
            "portRangeEnd": 8,
            "type": "INGRESS"
          }
        }
      ],
      "offset": 0,
      "limit": 1000,
      "_links": {
        "prev": "<PREVIOUS-PAGE-URI>",
        "self": "<THIS-PAGE-URI>",
        "next": "<NEXT-PAGE-URI>"
      }
    },
    "securitygroups": {
      "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
      "type": "collection",
      "href": "<RESOURCE-URI>",
      "items": [
        {
          "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
          "type": "security-group",
          "href": "<RESOURCE-URI>",
          "metadata": {
            "etag": "45480eb3fbfc31f1d916c1eaa4abdcc3",
            "createdDate": "2015-12-04T14:34:09.809Z",
            "createdBy": "user@example.com",
            "createdByUserId": "user@example.com",
            "lastModifiedDate": "2015-12-04T14:34:09.809Z",
            "lastModifiedBy": "user@example.com",
            "lastModifiedByUserId": "63cef532-26fe-4a64-a4e0-de7c8a506c90",
            "state": "AVAILABLE"
          },
          "properties": {
            "name": "My security group",
            "description": "My security group description"
          },
          "entities": {
            "rules": {
              "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
              "type": "collection",
              "href": "<RESOURCE-URI>",
              "items": [
                {
                  "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
                  "type": "firewall-rule",
                  "href": "<RESOURCE-URI>",
                  "metadata": {
                    "etag": "45480eb3fbfc31f1d916c1eaa4abdcc3",
                    "createdDate": "2015-12-04T14:34:09.809Z",
                    "createdBy": "user@example.com",
                    "createdByUserId": "user@example.com",
                    "lastModifiedDate": "2015-12-04T14:34:09.809Z",
                    "lastModifiedBy": "user@example.com",
                    "lastModifiedByUserId": "63cef532-26fe-4a64-a4e0-de7c8a506c90",
                    "state": "AVAILABLE"
                  },
                  "properties": {
                    "name": "My resource",
                    "protocol": "TCP",
                    "sourceMac": "00:0a:95:9d:68:16",
                    "ipVersion": "IPv4",
                    "sourceIp": "22.231.113.64",
                    "targetIp": "22.231.113.64",
                    "icmpCode": 0,
                    "icmpType": 8,
                    "portRangeStart": 8,
                    "portRangeEnd": 8,
                    "type": "INGRESS"
                  }
                }
              ],
              "offset": 0,
              "limit": 1000,
              "_links": {
                "prev": "<PREVIOUS-PAGE-URI>",
                "self": "<THIS-PAGE-URI>",
                "next": "<NEXT-PAGE-URI>"
              }
            },
            "nics": "[Circular Reference]",
            "servers": "[Circular Reference]"
          }
        }
      ],
      "offset": 0,
      "limit": 1000,
      "_links": {
        "prev": "<PREVIOUS-PAGE-URI>",
        "self": "<THIS-PAGE-URI>",
        "next": "<NEXT-PAGE-URI>"
      }
    }
  }
}

Last updated

Was this helpful?